import React, { Component } from 'react';
import Header from './components/Header';
import SpecieHome from './components/SpecieHome';
import { Route, Redirect, Switch } from 'react-router-dom';
import Specie from './components/Specie';
import Footer from './components/Footer'
import AllSpecies from './components/AllSpecies'
import Ladakh_portal from './components/Ladakh_portal'
import LadakhGroupView from './components/LadakhGroupView'
import Bibliography from './components/Bibliography'
import Culture  from './components/Culture';
import { NotFound } from './components/NotFound';
import Redesign from './components/Redesign';
import Team from './components/Team';
import GroupSpecie from './components/GroupSpecie';
import FamilySpecie from './components/FamilySpecie';
import GenusSpecie from './components/GenusSpecie';
import SpecieListSpecie from './components/SpecieListSpecie';
import WildlifeDepartment from './components/WildlifeDepartment';
import { api } from './api';
import Unionterritory from './components/Unionterritory';



 
class App extends Component {

  state = {
    downloadCount: 0 ,
   Grouptype :""

  }
     
     

  updateDownloadListAPi = (groupName) => {
     
    // let groupName = this.props.location.pathname.substring(this.props.location.pathname.lastIndexOf('/') + 1)
   // console.log(groupName, '21321321321')
    fetch(`${api.visitorCount}/?type=${groupName}`)
      .then(response => {
        if (!response || !response.ok) throw Error(response.status);
        return response.json()
      })
      .then(({ data }) => {
         
        //fetch no of total pdf downloaded
        fetch(`${api.downloadPdfCount}`)
          .then(response => {
            if (!response || !response.ok) throw Error(response.status);
            return response.json()
          })
          .then(({ data }) => {
             
            this.setState({ downloadCount: data })
          })
          .catch(err => console.log('could not fetch total pdf count', err))

      })
      .catch(err => console.log('could not fetch biodiversity pdf count', err))
  }


  render() {
    this.state.Grouptype = JSON.parse(localStorage.getItem("group_type"));
   // console.log(this.state.Grouptype,"app.jsx called")
    return (
      <div className='app'>
        
        <Header />
        <Switch>
          <Redirect exact to='/ladakh' from='/' />
          <Route exact path='/ladakh' render={props => <Ladakh_portal {...props} />} />
          <Route exact path='/ladakh/not_found' component={NotFound} />
          <Route exact path='/ladakh/team' component={Team} />
          <Route exact path='/ladakh/:ladakhGroup' render={props => <Redesign {...props} updateDownloadListAPi={this.updateDownloadListAPi} />} />
          <Route exact path='/ladakh/biodiversity/:type/all-species' component={AllSpecies} />

          <Route exact path='/ladakh/biodiversity/:type' component={SpecieHome} />
          <Route exact path='/ladakh/bibliography/:type' component={Bibliography} />
          <Route exact path='/ladakh/culture/:type' component={Culture} />
          <Route exact path='/ladakh/introduction/:type' component={WildlifeDepartment} />
          <Route exact path='/ladakh/introduction/:type' component={Unionterritory} />
          
          
          <Route exact path='/ladakh/biodiversity/plant/:group' component={GroupSpecie} />
          <Route exact path='/ladakh/biodiversity/plant/:group/:family' component={FamilySpecie} />
          <Route exact path='/ladakh/biodiversity/plant/:group/:family/:genus' component={GenusSpecie} />
          <Route exact path='/ladakh/biodiversity/plant/:group/:family/:genus/:species' component={SpecieListSpecie} />
          <Route exact path='/ladakh/biodiversity/plant/:group/:family/:genus/:species/:species__:id'
            render={props => <Specie updateDownloadListAPi={this.updateDownloadListAPi} {...props} />} />

          <Route exact path='/ladakh/biodiversity/:type/:family' component={FamilySpecie} />
          <Route exact path='/ladakh/biodiversity/:type/:family/:genus' component={GenusSpecie} />
          <Route exact path='/ladakh/biodiversity/:type/:family/:genus/:species' component={SpecieListSpecie} />
          <Route exact path='/ladakh/biodiversity/:type/:family/:genus/:species/:species__:id'
            render={props => <Specie updateDownloadListAPi={this.updateDownloadListAPi} {...props} />} />
          
          
          
          {/* <Route exact path='/ladakh/biodiversity/:type/:group/family' component={SpecieHome} />
          <Route exact path='/ladakh/biodiversity/:type/:group/:family/:genus' component={SpecieHome} />
          <Route exact path='/ladakh/biodiversity/:type/:group/:family/:genus/:species' component={SpecieHome} /> */}

           
        </Switch>
        <Footer downloadCount={this.state.downloadCount} />

      </div>

    )
  }
}

export default App
