import React, { Component } from 'react';
import { api } from '../api';
import Breadcrumb from 'react-bootstrap/Breadcrumb'




export default class AllSpecies extends Component {
  constructor(props) {
    super(props)

    this.state = {
      data: []

    };
  }

  componentDidMount() {
    const path = this.props.location.pathname

    const groupName = path.split('/')[3]

    // if (!groupName) this.props.history.push('/ladakh/biodiversity')
    this.fetchData(groupName);
  }
  onItalicData = (value) => {
    let data = value
    let strEle = data.split(' ').filter(elm => elm !== "")
    let italicWord = strEle.slice(0, 2).join(" ")
    let nonItalic = strEle.slice(2, strEle.length + 1).join(" ")
    return (<p>
      <i>Species : {italicWord} </i>
      {nonItalic}
    </p>)
  }
  onItalicSpeciesData = (value) => {
    ///console.log(value, 'dsadsa')
    value = String(value)

    let strEle = value.split(' ').filter(elm => elm !== "")
    // console.log(strEle,'dsadasda')
    let italicWord = value.replace("&nbsp;", " ")
    let nonItalic = strEle.slice(2, strEle.length + 1).join(" ")

    return (<>
      <i>{italicWord}</i>
      {nonItalic}
    </>)
  }


  fetchData(groupName) {
    fetch(`${api.speciesList}?type=${groupName}`)
      .then(response => response.json())
      .then(({ data }) => {
      //  console.log(data, 'all species')
        this.setState({
          data: data['species_list'],
          name: data['name'],
          groupName: data['type'],
          groupNameID: groupName
        }, () => console.log(this.state.data, 'state data'));


      }).catch(err => console.log('could not fetch all specie list', err))

  }

  routeToSpecie = (specie) => {
    if(this.state.groupName ==="plant"){
      this.props.history.push(`/ladakh/biodiversity/${this.state.groupName}/group/family/genus/species/${specie.species_name}__${specie.id}`)
      }
      else{
        this.props.history.push(`/ladakh/biodiversity/${this.state.groupName}/family/genus/species/${specie.species_name}__${specie.id}`) 
      }
  }


  render() {

    return (
      <>
        <div className='allSpecies'>


          <div className='allSpecies__breadcrumb'>
            <Breadcrumb>
              <Breadcrumb.Item bsPrefix='breadcrumb-item breadcrumb_style_whitePage' href="/ladakh">Home</Breadcrumb.Item>
              <Breadcrumb.Item bsPrefix='breadcrumb-item breadcrumb_style_whitePage' href="/ladakh/biodiversity">Biodiversity</Breadcrumb.Item>
              <Breadcrumb.Item bsPrefix='breadcrumb-item breadcrumb_style_whitePage' href={`/ladakh/biodiversity/${this.state.groupNameID}`}>{this.state.name}</Breadcrumb.Item>
              <Breadcrumb.Item active>{'All Species'}</Breadcrumb.Item>
            </Breadcrumb>
          </div>

          <div className="allSpecies__lists" >

            {this.state.data.length > 0 ?

              this.state.data.map((specie, i) => {
                if ("species" in specie) {
                  return (
                    <div className="allSpecies__specieSec" key={i + specie}>
                      <img className="allSpecies__specieImg" src={specie.thumbnail[0]} alt={specie.thumbnail[0]} />
                      <div className='specieHome__main_specieBox' style={{ padding: '0 1rem', paddingBottom: '1rem' }}>
                        <h3 className='specieHome__main_specieName'
                          onClick={() => this.routeToSpecie(specie)}>{specie.common_name[0]}</h3>
                        <p className='specieHome__main_specieContent'>{this.onItalicData(specie.species[0])}</p>
                        <p className='specieHome__main_specieContentName'>Genus : {specie.genus[0]}</p>
                      </div>
                    </div>)
                }
                else {
                  return (
                    <div className="allSpecies__specieSec" key={i + specie}>
                      <img className="allSpecies__specieImg" src={specie.thumbnail[0]} alt={specie.thumbnail[0]} />
                      <div className='specieHome__main_specieBox' style={{ padding: '0 1rem', paddingBottom: '1rem' }}>
                        <h3 className='specieHome__main_specieName'
                          onClick={() => this.routeToSpecie(specie)}>{this.onItalicSpeciesData(specie.species_name[0])}</h3>
                        <p className='specieHome__main_specieContent'>Genus : {specie.genus[0]}</p>
                        <p className='specieHome__main_specieContent'>Family : {specie.family[0]}</p>
                      </div>
                    </div>
                  )
                }
              })

              : ''}
          </div>
        </div>
      </>


    );
  }

}
