import React, { Component } from 'react';
import Sidebar from './Sidebar';
import { api } from '../api'
import BibliographyPage from './BibliographyPage';
import Pagination from './Pagination';
import { Link,Redirect, withRouter } from 'react-router-dom';
import Breadcrumb from 'react-bootstrap/Breadcrumb';


class Culture extends Component {
  state = {
    cultureHierarchy: [],
    sidebarData: true,
    detailData: true,
    cultureData: [],
    currentPage: 1,
    postsPerPage: 100000,
    elementName: '',
    searchKeyword: '',
    searchKeywordGroup: '',
    heading: ''
  }



  // For componentDidMount
  componentDidMount() {
    const path = this.props.location.pathname
    let currentPath = path.substring(path.lastIndexOf('/') + 1)
    console.log(currentPath, 'sdsadsadsad')

    this.fetchcultureHier(currentPath)

  }

//  fetchBibliographySearchElement = (searchKeyword, searchKeywordGroup) => {
//    fetch(`${api.bibliographySearch}?type=biodiversity&group=${searchKeywordGroup}&keyword=${searchKeyword}`)
//      .then(response => {
//        if (!response || !response.ok) throw Error(response.status);
//        return response.json()
//      })
//      .then(({ data }) => {
//        console.log(data, 'bibliography search result data', searchKeyword)
//        let refineData = data.data.map((e) => {
//          let arr = e.split(' ')
//          let arr2 = arr.map((el) => {
//            // console.log(el, 'Check 1')
//            // let removeExtraChar = el.match(/p/i)
//            // console.log(removeExtraChar)
//
//            return el.replace(new RegExp(`\\b${searchKeyword}\\b`, 'gi'), `<mark class='text-capitalize'>${searchKeyword}</mark>`)
//
//
//          })
//
//          // console.log(arr2, 'CHECK 2')
//          return arr2.join(' ')
//        })
//
//        console.log(refineData, 'CHECK 3')
//
//        this.setState({ bibliographyData: refineData, searchKeyword, searchKeywordGroup },
//          () => localStorage.removeItem('bibliographySearchIteam'))
//
//
//      })
//      .catch(err => console.log('could not fetch bibliography search element data', err))
//  }


  fetchcultureHier = (entit) => {
   // console.log(entit , "heir")
    fetch(`${api.cultureHier}?type=${entit}`)
      .then(response => {
        if (!response || !response.ok) throw Error(response.status);
        return response.json()
      })
      .then((data) => {
       // console.log(data.hier_level[0]['list_ele'][0].name, 'culture hier')
        this.setState({
          cultureHierarchy: data['hier_level'],
          elementName: data.hier_level[0]['list_ele'][0].id,
         // heading:data.hier_level[0]['list_ele'][0].name
        }, () => {
          const { searchKeyword, searchKeywordGroup } = { ...JSON.parse(localStorage.getItem('cultureSearchIteam')) }
        //console.log(this.state.cultureHierarchy)
       // console.log(this.state.elementName)
          searchKeyword ?
            this.fetchcultureSearchElement(searchKeyword, searchKeywordGroup) :
            this.fetchcultureData(entit)

        })
      })
      .catch(err => console.log('could not fetch culture hierarchy', err))
  }


  fetchcultureData = (currentpath) => {
    //  TO DO 
     
//console.log(this.state.elementName,"abababab")
    fetch(`${api.cultureData}?type=${currentpath}&element=${this.state.elementName}`)
      .then(response => {
        if (!response || !response.ok) throw Error(response.status);
        return response.json()
      })
      .then(({ data }) => {
        //console.log(data, 'culture data')
        var Heading = this.state.elementName
        var Heading = Heading.replace(/[#_]/g,' ');
        this.setState({ cultureData: data.element_data,
          heading:Heading})

      })
      .catch(err => console.log('could not fetch culture data', err))
  }

  getElementData = (name, currentPath) => {
    // let name1 = name === 'political sciences' ? 'political_science' : name
    this.setState({ elementName: name, searchKeywordGroup: '', searchKeyword: '' }, () => this.fetchcultureData(currentPath))

  }


  render() {

    const pageName= this.props.match.params.type
    const pagename= pageName.charAt(0).toUpperCase().concat(pageName.slice(1) )
    const pgname=pagename.replace(/_/g ," ")
    


    // re-route if group not exists
    const path = this.props.location.pathname
    let currentLocation = path.substring(path.lastIndexOf('/') + 1)
    //console.log(currentLocation, 'culjas;ld')
    // if (!['biodiversity'].includes(currentLocation)) return <Redirect to='/ladakh/not_found' />

    // get current posts
    const { cultureData, currentPage, postsPerPage, searchKeyword, searchKeywordGroup } = this.state;

    const indexOfLastPost = currentPage * postsPerPage;
    const indexOfFirstPost = indexOfLastPost - postsPerPage;
    const currentPosts = cultureData.slice(indexOfFirstPost, indexOfLastPost);

    // change page
    const paginate = (pageNumber) => this.setState({ currentPage: pageNumber });
    return (
      <section >
      <nav style={{marginTop:16 , paddingLeft:0}} aria-label="breadcrumb">
  <ol className="breadcrumb">
    <li className="breadcrumb-item"><Link to="/ladakh">Home</Link></li>
    <li className="breadcrumb-item"><Link to="/ladakh/culture">Culture</Link></li>
    <li className="breadcrumb-item active" aria-current="page">{`${pgname}`}</li>
  </ol>
</nav>
      <main className='bioliography' >
        {this.state.cultureHierarchy.length ? <Sidebar
          list={this.state.cultureHierarchy}
          hasFunction
          getElementData={this.getElementData}
          currentPath={currentLocation} /> : ''}
        <div>
        <div className='bioliography__body'>
          {this.props.forSearchResult ? 'Searched Result' :
            <>
              {searchKeyword ?
                <>
                  <h1 className='bioliography__heading'>Search results: {searchKeyword}</h1>
                  <h3 className='bioliography__heading' style={{ marginTop: '2rem' }}>{searchKeywordGroup}</h3>


                </> :
                <h1 className='bioliography__heading'>{this.state.heading}</h1>
              }

              <BibliographyPage data={currentPosts} />
             {/*  {cultureData.length > 9 ?
               <Pagination postsPerPage={postsPerPage} totalPosts={cultureData.length} paginate={paginate} /> : ''} */}
              

            </>}

        </div>
        </div>
      </main>
      </section >
    )
  }
}

export default withRouter(Culture)