import React, { Component } from 'react'
import { api } from '../api';
import SpecieBanner from './SpecieBanner';
import Breadcrumb from 'react-bootstrap/Breadcrumb';
import Loader from 'react-loader-spinner';
import CustomBreadcrumb from './CustomBreadcrumb';
import CustomBreadcrumbItem from './CustomBreadcrumbItem';



class FamilySpecie extends Component {

    constructor(props) {
        super(props)

        this.state = {
            specieCounts: {},
            specieList: [],
            bannerImage: [],
            bannerInfo: {},
            specieGroupName: '',
            groupName: '',// related to path name
            groupList: [],
           counts : {} ,
           banner : false ,
           groupType:""

        }
    }


    componentDidMount() {

        let path = this.props.location.pathname
        //console.log(this.props, '21321321321')
        // get group name from the window location path
       // console.log(path.split('/'), 'path')

        let groupName = path.split('/')[3]
       // console.log(groupName, 'Familygroup_name')
        this.state.groupType = groupName 
        this.speciesCount(groupName);

        this.speciesList(groupName);

        this.typeList(groupName);

    }

    speciesCount = (groupName) => {
        console.log('family api called')
        fetch(`${api.speciesCount}?type=${groupName}`)
            .then((response) => {
                if (!response || !response.ok) throw Error(response.status);
                return response.json()
            })
            .then(({ data }) => {
              //  console.log(data, 'specie count')
                this.setState({
                   specieCounts: data.specie_count,
                    bannerImage: data.banner_images,
                    bannerInfo: data.banner_info,
                    specieGroupName: data.heading[0],
                    groupName
                }, () => console.log("data"))

            })
            .catch((err) => console.log('could ot fetch specie count data', err))
    }


    speciesList = (groupName) => {
        fetch(`${api.speciesList}?type=${groupName}&count=yes`)
            .then((response) => {
                if (!response || !response.ok) throw Error(response.status);
                return response.json()
            })
            .then(({ data }) => {
               // console.log(data, 'specie list')
                this.setState({ specieList: data['species_list'] })

            })
            .catch((err) => console.log('could not fetch specie list data', err))
    }


    typeList = (groupName) => {
        let eleName = this.props.location.nameEle ? this.props.location.nameEle : ''
        let idName = this.props.location.id ? this.props.location.id : 'family'

        fetch(`${api.typeData}?type=${groupName}&id=${idName}&name=${eleName}`)
            .then((response) => {
                if (!response || !response.ok) throw Error(response.status);
                return response.json()
            })
            .then(({ data }) => {
              //  console.log(data, 'type list')
                if(eleName.length >0){
                    this.setState({ groupList: data.data,
                        counts: data.specie_count,
                        banner : true
                         })          }
                else{
                    this.setState({ groupList: data,
                        banner :false
                         }) }
            })
            .catch((err) => console.log('could not fetch type list data', err))
    }


    render() {
        return (
            <div className='specieHome'>
                {this.state.banner ?
                 <SpecieBanner
                 title={this.state.bannerInfo['title']}
                 specieCounts={this.state.counts}
                 bannerImage={this.state.bannerImage}
                 type={this.state.groupName} />
                : ''}
                {!this.state.banner ?
                <SpecieBanner
                    title={this.state.bannerInfo['title']}
                    specieCounts={this.state.specieCounts}
                    bannerImage={this.state.bannerImage}
                    type={this.state.groupName} />:''}

                <div className="specieHome__main">

                    <CustomBreadcrumb>
                        <CustomBreadcrumbItem path='/ladakh' text='Home' />
                        <CustomBreadcrumbItem path='/ladakh/biodiversity' text='Biodiversity' />
                        <CustomBreadcrumbItem path={`/ladakh/biodiversity/${this.state.groupName}`} text={this.state.specieGroupName} />
                      {  this.state.groupType =="plant" ?
                      <CustomBreadcrumbItem path={`/ladakh/biodiversity/${this.state.groupName}/group`} text='Group' />
                      :''}
                        <CustomBreadcrumbItem active text={'Family'} />
                    </CustomBreadcrumb>

                    {this.state.groupList.length > 0 ?
                        <>

                            <h1 className='specieHome__main_title'>{this.props.location.nameEle ? `Families in ${this.props.location.nameEle} ` : `Browse All Family`}</h1>

                            <div className='specieHome__listItem'>
                                {this.state.groupList.map((elem, i) => {
                                    if(this.state.groupType=="plant"){
                                    return (
                                        <>
                                            <h4 className='specieHome__main_specieName'
                                                onClick={() => this.props.history.push({
                                                    pathname: `/ladakh/biodiversity/${this.state.groupName}/group/family/genus`,
                                                    nameEle: elem,
                                                    id: 'family'

                                                })} key={elem + i + i}>{elem}</h4>
                                            {/* <br /> */}
                                        </>
                                    )}
                                    else{
                                        return (
                                            <>
                                                <h4 className='specieHome__main_specieName'
                                                    onClick={() => this.props.history.push({
                                                        pathname: `/ladakh/biodiversity/${this.state.groupName}/family/genus`,
                                                        nameEle: elem,
                                                        id: 'family'
    
                                                    })} key={elem + i + i}>{elem}</h4>
                                                {/* <br /> */}
                                            </>
                                        )
                                    }
                                }
                                )}
                            </div>
                        </> : <Loader
                            type="ThreeDots"
                            color="#3c6382"
                            height={100}
                            width={100}
                        />}

                </div>
            </div>
        )
    }
}

export default FamilySpecie
