import React, { useState, useEffect } from 'react';
import { withRouter } from "react-router-dom";
import { api } from "../api"
import home_icon from '../assets/home.png';
import { SearchBoxWithSuggestion } from './SearchBoxWithSuggestion';

const Header = ({ location, history }) => {


  //console.log(location.pathname.split('/'))
  const pathLength = location.pathname.split('/').length
  //console.log(pathLength)
  const groupName = location.pathname.split('/')[3] // passing group name according to search
  //console.log(groupName)
  const searchBox =
    location.pathname.includes('/ladakh/biodiversity/') ?
      // <div className='header__searchSec'>
      //   <img src='https://ladakh-raw-data.s3.ap-south-1.amazonaws.com/assets/search.svg' className='header__inputSearchLogo' />
      //   <input className='header__searchBar' type='text' placeholder='Species or family' />
      // </div> : ''
      <SearchBoxWithSuggestion
        history={history}
        placeholder='Species, family or more'
        groupName={groupName}
        apiUrl={api.ladakhSearch}
        searchFor='biodiversity'
        changeStyle
        reloadPage={pathLength > 4}
      /> :
      location.pathname.includes('/ladakh/bibliography/') ?
        <SearchBoxWithSuggestion
          history={history}
          placeholder='Reference, keyword...'
          groupName={''}
          apiUrl={api.bibliographySearch}
          searchFor='bibliography'
          changeStyle
          reloadPage
        />
        : ''



  const home = location.pathname !== '/ladakh' ?
    <img src={home_icon} className='header__logoImg' title='Go to home' onClick={() => history.push('/ladakh')} />
    : ''

  return (

    location.pathname === '/ladakh' ? ''
      // <img
      //   className='header__sideLogo'
      //   src={'https://ladakh-info-system-raw-data.s3.ap-south-1.amazonaws.com/assets/wlpd.png'} />

      : <header className='header'>
        <div className='header__logo_sec'>
          {home}
          <h1 className='header__logo'>Ladakh Information System</h1>
        </div>
        {searchBox}
      </header>

  )
}

export default withRouter(Header)

