import React, { Component } from 'react';
import bird from "../assets/bird.png";
import rightArrow from "../assets/rightarrow.png";
import { api } from '../api';
import Breadcrumb from 'react-bootstrap/Breadcrumb';



class LadakhGroupView extends Component {
  state = {
    groupData: {}
  }
  componentDidMount() {
    const path = this.props.location.pathname
    let groupName = path.substring(path.lastIndexOf('/') + 1)
    this.fetchGroupData(groupName)
   // console.log(groupName)
  }

  fetchGroupData = (groupName) => {
    fetch(`${api.ladakhGroupData}?type=${groupName}`)
      .then(response => {
        if (!response || !response.ok) throw Error(response.status);
        return response.json()
      })
      .then(({ data }) => {
        //console.log(data, 'group data')
        this.setState({ groupData: data })

      })
      .catch(err => console.log('could not fetch ladakh group data', err))
  }
  render() {

    const path = this.props.location.pathname
    let currentLocation = path.substring(path.lastIndexOf('/') + 1)
    //console.log(currentLocation, 'group_name')

    return (
      Object.keys(this.state.groupData).length > 0 ?
        <div className="ladakhGroupView">
          <Breadcrumb>
            <Breadcrumb.Item bsPrefix='breadcrumb-item breadcrumb_style_whitePage' href="/ladakh">Home</Breadcrumb.Item>
            <Breadcrumb.Item active>{currentLocation}</Breadcrumb.Item>
          </Breadcrumb>

          <div className="ladakhGroupView__infoSec">


            <div className='ladakhGroupView__infobar'>

              <h1 className='ladakhGroupView__info_title'>{this.state.groupData['type']}</h1>

              {this.state.groupData['element']['content'].map((content, i) => {
                return (
                  <>
                    <p key={i}>{content}</p>
                    {/* <br /> */}
                  </>)
              })}

            </div>
            <img src={this.state.groupData['element']['image']} className='ladakhGroupView__info_img' alt='bird' />

          </div>

          <div className='ladakhGroupView__gridSec'>
            {this.state.groupData['element']['sub_element'].map((ele, i) => {
              return (
                <div className="ladakhGroupView__grid" key={i}>
                  <h1 className='ladakhGroupView__grid_title'
                    onClick={() => this.props.history.push({
                      pathname: `/ladakh/${currentLocation}/${ele['id']}`,
                      groupName: ele['name']
                    })}>
                    {ele['name']}
                  </h1>
                  
                  <p>{ele['content']}</p>
                  <img src={rightArrow} className='ladakhGroupView__grid_arrow' alt='right-arrow' />
                </div>
              )

            })}

          </div>
        </div> : ''

    );
  }
}


export default LadakhGroupView;