import React, { Component } from 'react'
import { api } from '../api';
import arrow from '../assets/right-arrow1.svg';
import { SearchBoxWithSuggestion } from '../components/SearchBoxWithSuggestion'
import {Link} from 'react-router-dom';
import { Carousel } from 'react-bootstrap';


export class Ladakh_portal extends Component {
    
carousel_img=["https://storage.googleapis.com/ladakh-info-system-raw-data/home_images/1920X1020.jpg",
             "https://storage.googleapis.com/ladakh-info-system-raw-data/home_images/1920X1280.jpg",
             "https://storage.googleapis.com/ladakh-info-system-raw-data/home_images/1920X1282.jpg",
             "https://storage.googleapis.com/ladakh-info-system-raw-data/home_images/1920X964.jpgg",
             "https://storage.googleapis.com/ladakh-info-system-raw-data/home_images/2560X1440.jpg"]



    render() {
        return (
            

            < div className='ladakh'>
              <div className="carousel-background">
    <Carousel fade={true} indicators={true} controls={false}>
      {this.carousel_img.map((img, i) => {
        const backgroundImageStyle = {
          backgroundImage: `url(${img})`
        };
        return (
          <Carousel.Item interval={10000} key={i + img}>
            <div className="carousel-image" style={backgroundImageStyle} />
          </Carousel.Item>
        );
      })}
    </Carousel>
  </div>
            <div className='overcontent'>
                {/* <img style={{height:"100px",width:"300px",position:"relative",right:"-1226px"}} src={'https://ladakh-raw-data.s3.ap-south-1.amazonaws.com/assets/wlpd.png'}/> */} 
                <div >


                    <h1 className="ladakh__heading">Ladakh Information System</h1>
                    <SearchBoxWithSuggestion
                        {...this.props}
                        placeholder='Search for plant, birds, animal and more..'
                        groupName=""
                        apiUrl={api.ladakhSearch}
                        searchFor = "home"
                         />
                </div>

                <div className='grid-container' >
                    <div className="grid-container-text ele1">
                        <p onClick={() => this.props.history.push(
                            {
                                pathname: '/ladakh/introduction',
                                groupName: 'union_territory_of_ladakh'
                            })}>Introduction</p>
                        <img className="ladakh__arrow" src={arrow} />
                    </div>

                    <div className="grid-container-text ele2" onClick={() => {
                        this.props.history.push({
                            pathname: '/ladakh/biodiversity',
                            state: 'biodiversity',
                            groupName: 'plant'
                        })

                    }}>
                        <p >Biodiversity</p>
                        <img className="ladakh__arrow" src={arrow} />
                    </div>

                    <div className="grid-container-text ele3"
                        onClick={() => this.props.history.push({
                            pathname: '/ladakh/bibliography',
                            groupName: 'biodiversity'
                        })}>
                        <p >Bibliography</p>
                        <img className="ladakh__arrow" src={arrow} />
                    </div>

                    <div className="grid-container-text ele4"
                        onClick={() => this.props.history.push({
                            pathname: '/ladakh/socioeconomic',
                            groupName: 'district'
                        })}>
                        <p >Socioeconomic</p>
                        <img className="ladakh__arrow" src={arrow} />
                    </div>

                    <div className="grid-container-text ele5">
                                           
                        
                         <Link style={{"text-decoration":"none" ,"color":"white"}} to={{ pathname: "http://65.1.252.225/gis-portal" }} target="_blank"><p >Geospatial</p></Link>
                        {/* <a href="http://demo.sgligis.com:10024/GIS/Home/GISPortal"> 
                        <p >Geospatial</p></a>*/}
                        <img className="ladakh__arrow" src={arrow} />
                    </div>

                    <div className="grid-container-text ele6"
                        onClick={() => this.props.history.push({
                            pathname: '/ladakh/culture',
                            groupName: 'manipa'})}> 
                        <p >Culture</p>
                        <img className="ladakh__arrow" src={arrow} />
                    </div>

                </div>
                </div>
            </div >

        )
    }
}

export default Ladakh_portal


