import React, { Component } from 'react';
import bird from "../assets/bird.png";
import rightArrow from "../assets/right-arrow1.svg";
import { api } from '../api';
import Breadcrumb from 'react-bootstrap/Breadcrumb';
import img1 from '../assets/img_1.jpg';
import img2 from '../assets/img_2.jpg';
import graphImg from '../assets/graph.png';
import ReactToPrint from "react-to-print";
import PDF from '../assets/pdf.svg';
import CustomBreadcrumb from './CustomBreadcrumb';
import CustomBreadcrumbItem from './CustomBreadcrumbItem';



class Redesign extends Component {

  state = {
    ladakhData: {},
    data: {},
    groupName: '',
  }

  componentDidMount() {
    const path = this.props.location.pathname
   // console.log(path)
    let groupName = path.substring(path.lastIndexOf('/') + 1)
    this.fetchGroupData(groupName)
  }

  onGroupClick = (currentLocation, ele) => {
   // console.log(ele,currentLocation,'checked1')
    //this.getGroupDatabyName(ele['id'])
    //console.log(this.state.data['name'])
    // console.log(this.state.data['type'])
    //console.log(`/ladakh/${currentLocation}/${ele['id']}`)
    if(currentLocation=="socioeconomic" || currentLocation=="geospatial" ){
      this.props.history.push({
        pathname: `/ladakh/not_found`
      })
    }
    else{
    this.props.history.push({
      pathname: `/ladakh/${currentLocation}/${ele['id']}`,
      groupName: ele['id']
    })}
  }

  fetchGroupData = (groupName) => {
    //console.log(groupName)
    fetch(`${api.ladakhData}?type=${groupName}`)
      .then(response => {
        if (!response || !response.ok) throw Error(response.status);
        return response.json()
      })
      .then(({ data }) => {
       // console.log(data, 'ladakh data')
        this.setState({ ladakhData: data }, () => this.getGroupDatabyName(data['default_group_name']))

      })
      .catch(err => console.log('could not fetch ladakh group data', err))
  }

  getGroupDatabyName = (groupName) => {
    fetch(`${api.ladakhGroupData}?type=${groupName}`)
      .then(response => {
        if (!response || !response.ok) throw Error(response.status);
        return response.json()
      })
      .then(({ data }) => {
        //console.log(data, 'group data')
        this.setState({ data: data, groupName: groupName })

      })
      .catch(err => console.log('could not fetch ladakh group data', err))
  }

  render() {
    //console.log(this.state.data['type'])
    console.log(this.state.ladakhData.element , "1234456788")
    const path = this.props.location.pathname
    let currentLocation = path.substring(path.lastIndexOf('/') + 1)
    //console.log(currentLocation, 'group_name')

    return (
      Object.keys(this.state.ladakhData).length > 0 && Object.keys(this.state.data).length > 0 ?
        <>

          <div className="ladakhGroupView" style={{ padding: 0, background: '#f1f2f6' }}>

            <div>
              <div style={{ padding: '2rem 6rem 0 6rem', textTransform: "capitalize" }}>
                <CustomBreadcrumb>
                  <CustomBreadcrumbItem path='/ladakh' text='Home' />
                  <CustomBreadcrumbItem active text={currentLocation} />
                </CustomBreadcrumb>

              </div>
              <div className='redesign__download_pdfSec'>
                <p className='redesign__download_title'>Download as</p>

                {/* generating pdf with using of refs */}
                <ReactToPrint
                  trigger={() => <img src={PDF} width='45' height='45' title='Print this out!' className='specie__pdfImg' alt='pdf' />}
                  content={() => this.componentRef}
                  onAfterPrint={() => this.props.updateDownloadListAPi('biodiversity')}
                  documentTitle='biodiversity'
                />
              </div>
            </div>





            {/* //  <div className="ladakhGroupView__infoSec" style={{ padding: '0 6rem 0 6rem' }}>
              <div className='ladakhGroupView__infobar' style={{ maxWidth: '100%' }}>

                <h1 className='ladakhGroupView__info_title'>{this.state.ladakhData['type']}</h1>

                {this.state.ladakhData['element']['content'].map((content, i) => {
                  return (
                    <>
                      <p key={i}>{content}</p>
                      //<br /> comment
                    </>)
                })}

              </div>
              //<img src={this.state.ladakhData['element']['image']} className='ladakhGroupView__info_img' alt='bird' /> //comment

              </div> //*/}

            {/* <div className='ladakhGroupView__gridSec'>
            {this.state.ladakhData['element']['sub_element'].map((ele, i) => {
              return (
                <div className="ladakhGroupView__grid" key={i}>
                  <h1 className='ladakhGroupView__grid_title'
                    onClick={() => this.props.history.push({
                      pathname: `/ladakh/${currentLocation}/${ele['id']}`,
                      groupName: ele['name']
                    })}>
                    {ele['name']}
                  </h1>
                  <p>{ele['content']}</p>
                  <img src={rightArrow} className='ladakhGroupView__grid_arrow' alt='right-arrow' />
                </div>
              )

            })}

          </div> */}

            <div className='redesign__outerContainer'>
              <div className='redesign__innerContainer'>
                <div className='redesign__groupNavBar'>
                  {this.state.ladakhData['element']['sub_element'].map((ele, i) => {
                    console.log(currentLocation)
                    return (
                      <div key={ele + i}
                        className={`redesign__groupSec`}
                        onClick={() => this.onGroupClick(currentLocation, ele)}
                      >
                        <p className='redesign__groupName'>{ele.name}</p>
                        {/* <hr /> */}
                        {/* <p className='redesign__groupContent'>{ele.content}</p> */}
                      </div>

                    )
                  })}
                </div>
                <main className='redesign__main' id='fullscreen' ref={(el) => (this.componentRef = el)} >

                  <div className='redesign__groupBody'>
                    <div className='redesign__groupBody_leftSec'>
                      {/*  <h1 className='redesign__groupBody_heading'>{this.state.data['name']}</h1> */}
                      <div className='redesign__groupBody_imgSec'>

                        {/* {this.state.data['group_img'].map((link, i) => {
                        return <img src={link} key={link + i} className='redesign__groupBody_img' alt={'img' + i} />
                      })} */}

                      </div>

                      {/* <button type='button' className='redesign__groupBody_btn'
                      onClick={() => this.props.history.push({
                        pathname: `/ladakh/${currentLocation}/${this.state.data['type']}`,
                        groupName: this.state.data['name']
                      })}>
                      Explore More
                      <img src={rightArrow} className='redesign__groupBody_btn_arrow' />
                    </button> */}
                    </div>

                    <div className='redesign__groupBody_rightSec'>

                      <h1 className='ladakhGroupView__info_title'></h1>
                      
                      <div >

                      {this.state.ladakhData['element']['content'].map((content, i) => {
                        //console.log(content ,"11111")
                          if (content.type === "text") {
                            return <p key={i}>{content.content}</p>;
                          }else if (content.type === "heading")
                          {//console.log(content)
                           return  <p style={{fontSize:"1.8rem" , marginTop:"1px" , marginBottom:"1px"}}key={i}><b>{content.content.replace("[" , "")}</b></p>;
                          }
                           else if (content.type === "image"){
                             //console.log(content)
                              return <img key={i} src={content.content} alt={`Image ${i}`}  />;
                            
                           }

                           
                          else if (content.type === "meta_data"){
                            return <p style={{marginTop:"1px" , marginBottom:"2px"}}key={i}><i>{content.content}</i></p>;
                          }

                        })
                        
                      }
                      </div>

                      {/*  
             {this.state.data['info'].map((content, i) => {
                return (
                  <>
                    <p key={i}>{content}</p>
                    <br /> 
                  </>)
              })} */}
                      {/*<p>{this.state.data['info']}</p>*/}
                      {/*{this.state.data && this.state.data['graph_info'] ?
                      <div className='redesign__groupBody_graph'>
                        <p>
                        {this.state.data['graph_info']}
                        </p>
                        <img src={this.state.data['graph_img'][0]} alt='graph' width='40%' />
            </div> : ''}*/}


                    </div>


                  </div>
                </main>
              </div>

            </div>

          </div>

        </> : ''

    );
  }
}


export default Redesign;