import React from 'react';
import { useEffect } from 'react';
import Autosuggest from 'react-autosuggest';
import { api } from '../api';
// import search from '../../SVGIcons/search.svg'

export const SearchBoxWithSuggestion = (props) => {


  useEffect(() => {
    if (props.changeStyle) {
      document.getElementsByClassName('react-autosuggest__input')[0].style.cssText = 'width:100%'
      document.getElementsByClassName('react-autosuggest__suggestions-container')[0].style.cssText = 'width:100%;position:absolute'
    }
  });

  

  const [element, setElement] = React.useState("")
  const [suggestions, setSuggestions] = React.useState([])
  return (
    <div className='autosuggest'>
      <Autosuggest
        inputProps={{
          placeholder: props.placeholder,
          autoComplete: '',
          name: 'element',
          id: 'element',
          value: element,
          onChange: (_event, { newValue }) => {
            setElement(newValue)
          }
        }}
        suggestions={suggestions}
        onSuggestionsFetchRequested={({ value }) => {
          
          //console.log(value, 'suggestion request')
          if (!value) {
            setSuggestions([]);
            return;
          }
          if(props.searchFor === "bibliography"){
            var type = props.history.location.pathname.slice(21,)
          }
          else if(props.searchFor === "biodiversity"){
            var type = "biodiversity"
          }
          else if(props.searchFor === "home"){
            var type = "biodiversity"
          }
          try {
            //console.log(props.history.location.pathname.slice(21,),"@@@@@@@@@@@@@@@@@@@@@@@@@@")
            
           // console.log(type,"2222")
            
            const url = `${props.apiUrl}?keyword=${value}&type=${type}&group=${props.groupName}`;

            fetch(url)
              .then(response => {
                if (!response || !response.ok) throw Error(response.status);
                return response.json()
              })
              .then(data => {
               // console.log(data, 'element name')
                props.searchFor === 'bibliography' ?
                  setSuggestions(data.data.key_elements.map(row => ({ name: row, groupTransform: '', searchkeyword: data.data.search_key })))
                  :
                  setSuggestions(data.name.map(row => ({ name: row.specie, id: row.id, group: row.group, groupTransform: row.group_trans })))

              })
              .catch(err => console.log('Could not get element name', err));

          }
          catch (e) {
            setSuggestions([]);
          }
        }}
        onSuggestionsClearRequested={() => {
          setSuggestions([]);
        }}
        onSuggestionSelected={(_event, { suggestion, method }) => {
          if (method === "enter" || method === 'click') {
            props.searchFor === 'bibliography' ?

              localStorage.setItem('bibliographySearchIteam', JSON.stringify({
                type : suggestion.entity,
                searchKeyword: suggestion.searchkeyword,
                searchKeywordGroup: suggestion.name,
              }))
              : console.log()
              if(suggestion.group==="plant")
              { props.history.push(`/ladakh/biodiversity/${suggestion.group}/group/family/genus/specie/${suggestion.name}__${suggestion.id}`)
                          }
              else{
              props.history.push(`/ladakh/biodiversity/${suggestion.group}/family/genus/specie/${suggestion.name}__${suggestion.id}`)
              }
            // reload the same page beacause same route path willn't perform
            props.reloadPage && window.location.reload()

          }
        }}
        getSuggestionValue={suggestion => suggestion.name}
        renderSuggestion={suggestion => <div className='underSuggestion'>
          <p className='underSuggestion_name'>{suggestion.name}</p>
          <p className='underSuggestion_type'>{suggestion.groupTransform}</p>
        </div>}


      />
      {/* <button className='autosuggest__btn' type='button' onClick={() => props.onClickSearchBox(element)}>
        <img src={search} alt='search' className='autosuggest__search' />
      </button> */}
    </div>
  )
}
