import React, { Component } from 'react'
class Sidebar extends Component {
  constructor(props) {
    super(props)

    this.state = {
      taxonomy: false,
      habitat: false,
      economicUses: false,
      distribution: false,
      commonNames: false,
      conservationStatus: false,
      habitatEcology: false,
    }

  }
  toggleDropDown = (listName) => {

    switch (listName) {
      case 'Taxonomy': this.setState({ taxonomy: !this.state.taxonomy })
        break;

      case 'Habitat and ecology': this.setState({ habitat: !this.state.habitat })
        break;

      case 'Economic uses': this.setState({ economicUses: !this.state.economicUses })
        break;

      case 'Distribution': this.setState({ distribution: !this.state.distribution })
        break;

      case 'Common names': this.setState({ commonNames: !this.state.commonNames })
        break;

      case 'Conservation status': this.setState({ conservationStatus: !this.state.conservationStatus })
        break;

      case 'Habitat ecology': this.setState({ habitatEcology: !this.state.habitatEcology })
        break;

    }

  }

  changeElementCSS = (listName) => {
    switch (listName) {
      case 'Taxonomy': return this.state.taxonomy ? 'sidebar__sublists--shown' : 'sidebar__sublists--hidden'

      case 'Habitat and ecology': return this.state.habitat ? 'sidebar__sublists--shown' : 'sidebar__sublists--hidden'

      case 'Economic uses': return this.state.economicUses ? 'sidebar__sublists--shown' : 'sidebar__sublists--hidden'

      case 'Distribution': return this.state.distribution ? 'sidebar__sublists--shown' : 'sidebar__sublists--hidden'

      case 'Common names': return this.state.commonNames ? 'sidebar__sublists--shown' : 'sidebar__sublists--hidden'

      case 'Conservation status': return this.state.conservationStatus ? 'sidebar__sublists--shown' : 'sidebar__sublists--hidden'

      case 'Habitat ecology': return this.state.habitatEcology ? 'sidebar__sublists--shown' : 'sidebar__sublists--hidden'

      default: return 'sidebar__sublists--shown'
    }
  }

  render() {
   //  console.log(this.props.list)
    return (
      <div className='sidebar'>
        <ul className='sidebar__lists' >
          {this.props.list.map((data, i) => {
          // console.log(data['list_name'])
            return <li key={i} className='sidebar__list' >
              <a href={`#${data['list_name']}`}
                onClick={() => this.toggleDropDown(data['list_name'])}
                className='sidebar__underlist'>{data['list_name']}</a>

              {data['list_ele'].length > 1 &&
                <ul className={`sidebar__sublists ${this.changeElementCSS(data['list_name'])}`}>
                  {data['list_ele'].map((ele, i) => {
                  // console.log(data['list_ele'].length)
                    return (
                      <li key={i + ele.id} className='sidebar__sublist'>
                        {this.props.hasFunction ?
                          <p className='sidebar__underSublist' onClick={()=>this.props.getElementData(ele.id,this.props.currentPath)}>{ele.name}</p>
                          : <a className='sidebar__underSublist' href={`#${ele.id}`} >{ele.name}</a>}
                      </li>
                    )
                  })}
                </ul>}
            </li>
          })}
        </ul>
      </div>

    )
  }
}

export default Sidebar
