import React from 'react';
import Carousel from 'react-bootstrap/Carousel';
import { withRouter } from "react-router-dom";

const SpecieBanner = ({
    title, specieCounts, bannerImage, type, history
}) => {
 

    const routeToElement = (path) => {
        history.push(`${path}`)
    }
    return (
        <div className='specieHome__banner'>

            <div className='specieHome__banner_captionSec individual'>

                <h1 className='specieHome__banner_captionTitle'>{title}</h1>
                {/*<p className='specieHome__banner_captionInfo'>{this.state.bannerInfo['info']}</p>*/}
                {Object.keys(specieCounts).length > 0 ?
                    <div className='specieHome__banner_specieCountSec'>
               {type == "plant"?
               <>
                        <div
                            onClick={() => routeToElement(`/ladakh/biodiversity/${type}/${specieCounts[0].name}`)} className='specieHome__banner_specieCount_list'>
                            <p className="specieHome__banner_specieCount_no">{specieCounts[0].count}</p>
                            <p className="specieHome__banner_specieCount_text">{specieCounts[0].name}</p>
                        </div>
                         
                        <div
                            onClick={() => routeToElement(`/ladakh/biodiversity/${type}/group/${specieCounts[1].name}`)} className='specieHome__banner_specieCount_list'>
                            <p className="specieHome__banner_specieCount_no">{specieCounts[1].count}</p>
                            <p className="specieHome__banner_specieCount_text">{specieCounts[1].name}</p>
                        </div>

                        <div
                            onClick={() => routeToElement(`/ladakh/biodiversity/${type}/group/family/${specieCounts[2].name}`)} className='specieHome__banner_specieCount_list'>
                            <p className="specieHome__banner_specieCount_no">{specieCounts[2].count}</p>
                            <p className="specieHome__banner_specieCount_text">{specieCounts[2].name}</p>
                        </div>

                        <div
                            onClick={() => routeToElement(`/ladakh/biodiversity/${type}/group/family/genus/${specieCounts[3].name}`)} className='specieHome__banner_specieCount_list'>
                            <p className="specieHome__banner_specieCount_no">{specieCounts[3].count}</p>
                            <p className="specieHome__banner_specieCount_text">{specieCounts[3].name}</p>
                        </div></>: ''}
                        {type != "plant"?
                        <>                       
                        <div
                            onClick={() => routeToElement(`/ladakh/biodiversity/${type}/${specieCounts[1].name}`)} className='specieHome__banner_specieCount_list'>
                            <p className="specieHome__banner_specieCount_no">{specieCounts[1].count}</p>
                            <p className="specieHome__banner_specieCount_text">{specieCounts[1].name}</p>
                        </div>

                        <div
                            onClick={() => routeToElement(`/ladakh/biodiversity/${type}/family/${specieCounts[2].name}`)} className='specieHome__banner_specieCount_list'>
                            <p className="specieHome__banner_specieCount_no">{specieCounts[2].count}</p>
                            <p className="specieHome__banner_specieCount_text">{specieCounts[2].name}</p>
                        </div>

                        <div
                            onClick={() => routeToElement(`/ladakh/biodiversity/${type}/family/genus/${specieCounts[3].name}`)} className='specieHome__banner_specieCount_list'>
                            <p className="specieHome__banner_specieCount_no">{specieCounts[3].count}</p>
                            <p className="specieHome__banner_specieCount_text">{specieCounts[3].name}</p>
                        </div></>: ''}

                    </div> : ''}

            </div>
            <Carousel fade={true} indicators={true} controls={false}>
                {bannerImage.length > 0 ? bannerImage.map((img, i) => {
                    return <Carousel.Item interval={10000} key={i + img}>
                        <img className="specieHome__banner_img" src={img} />
                    </Carousel.Item>
                }) : ''}
            </Carousel>
        </div>

    )
}


export default withRouter(SpecieBanner)


