import React, { Component } from 'react';
import Carousel from 'react-bootstrap/Carousel';
import { api } from '../api';
import Breadcrumb from 'react-bootstrap/Breadcrumb'
import "react-responsive-modal/styles.css";
import { Modal } from "react-responsive-modal";
import SpecieBanner from './SpecieBanner';
import Loader from 'react-loader-spinner';
import CustomBreadcrumb from './CustomBreadcrumb';
import CustomBreadcrumbItem from './CustomBreadcrumbItem';



const SpecieContext = React.createContext();
export class SpecieHome extends Component {
  constructor(props) {
    super(props)

    this.state = {
      specieCounts: {},
      specieList: [],
      bannerImage: [],
      bannerInfo: {},
      specieGroupName: '',
      groupName: '' ,
      groupType:''

    }
  }

  componentDidMount() {

    let path = this.props.location.pathname
    // get group name from the window location path
    let groupName = path.substring(path.lastIndexOf('/') + 1)
   
    this.speciesCount(groupName);

    this.speciesList(groupName);

  }
  onItalicData = (value) => {
    let data = value
    let strEle = data.split(' ').filter(elm => elm !== "")
    let italicWord = strEle.slice(0, 2).join(" ")
    let nonItalic = strEle.slice(2, strEle.length + 1).join(" ")
    return (<p>
      <i>Species : {italicWord} </i>
      {nonItalic}
    </p>)
  }
  onItalicSpeciesData = (value) => {
    let data = value
    let strEle = data.split(' ').filter(elm => elm !== "")
    let italicWord = strEle.slice(0, 2).join(" ")
    let nonItalic = strEle.slice(2, strEle.length + 1).join(" ")
    return (<p>
      <i>{italicWord} </i>
      {nonItalic}
    </p>)
  }



  speciesCount = (groupName) => {
    fetch(`${api.speciesCount}?type=${groupName}`)
      .then((response) => {
        if (!response || !response.ok) throw Error(response.status);
        return response.json()
      })
      .then(({ data }) => {
         
        this.setState({
          specieCounts: data.specie_count,
          bannerImage: data.banner_images,
          bannerInfo: data.banner_info,
          specieGroupName: data.heading[0],
          groupName
        }, () => console.log())

      })
      .catch((err) => console.log('could ot fetch specie count data', err))
  }


  speciesList = (groupName) => {
    fetch(`${api.speciesList}?type=${groupName}&count=yes`)
      .then((response) => {
        if (!response || !response.ok) throw Error(response.status);
        return response.json()
      })
      .then(({ data }) => {
         
        this.setState({ specieList: data['species_list'],
      groupType:data.type })
      localStorage.setItem("group_type", JSON.stringify(this.state.groupType));
      if(this.state.groupType!="plant"){
        localStorage.removeItem('group_type')
      }    

      })
      .catch((err) => console.log('could not fetch specie list data', err))
  }

  // getAllSpecieData = () => {

  //   fetch(`${api.specieName}?type=plant`)
  //     .then(response => response.json())
  //     .then(({ data }) => {
  //       console.log(data, 'specie lists')
  //       this.setState({ specieList: data })

  //     })
  //     .catch((err) => console.log('could ot fetch species list data', err))
  // }

  routeToSpecie = (specie) => {
    if(this.state.groupName ==="plant"){
    this.props.history.push(`/ladakh/biodiversity/${this.state.groupName}/group/family/genus/species/${specie.species_name}__${specie.id}`)
    }
    else{
      this.props.history.push(`/ladakh/biodiversity/${this.state.groupName}/family/genus/species/${specie.species_name}__${specie.id}`) 
    }
  }



  render() {
     

    return (
      <div className='specieHome'>
        <SpecieBanner
          title={this.state.bannerInfo['title']}
          specieCounts={this.state.specieCounts}
          bannerImage={this.state.bannerImage}
          type={this.state.groupName} />

        {/* <div className='specieHome__banner'>

          <div className='specieHome__banner_captionSec individual'>

            <h1 className='specieHome__banner_captionTitle'>{this.state.bannerInfo['title']}</h1>
            {Object.keys(this.state.specieCounts).length > 0 ?
              <div className='specieHome__banner_specieCountSec'>
                {this.state.specieCounts.map((specie, i) => {
                  return (
                    <div key={specie + i} className='specieHome__banner_specieCount_list'>
                      <p className="specieHome__banner_specieCount_no">{specie.count}</p>
                      <p className="specieHome__banner_specieCount_text">{specie.name}</p>
                    </div>
                  )
                })}

              </div> : ''}
         
          </div>
          <Carousel fade={true} indicators={true} controls={false}>
            {this.state.bannerImage.length > 0 ? this.state.bannerImage.map((img, i) => {
              return <Carousel.Item interval={10000} key={i + img}>
                <img className="specieHome__banner_img" src={img} />
              </Carousel.Item>
            }) : ''}
          </Carousel>
        </div> */}

        <div className="specieHome__main">


          <CustomBreadcrumb>
            <CustomBreadcrumbItem path='/ladakh' text='Home' />
            <CustomBreadcrumbItem path='/ladakh/biodiversity' text='Biodiversity' />
            <CustomBreadcrumbItem active text={this.state.specieGroupName} />
          </CustomBreadcrumb>

          {this.state.specieList.length > 0 ?
            <>

              <h1 className='specieHome__main_title'>{`Browse All ${this.state.specieGroupName}`}</h1>

              <div className='specieHome__main_specieLists'>
                {this.state.specieList.map((specie) => {
                  if ("species" in specie) {
                    return (
                      <div key={specie.id} className='specieHome__main_specieList'>
                        <img src={specie.thumbnail[0]} alt={specie.thumbnail[0]} className='specieHome__main_specieImg' />
                        <div className='specieHome__main_specieBox'>
                          <h3 className='specieHome__main_specieName'
                            onClick={() => this.routeToSpecie(specie)}>{specie.common_name[0]}</h3>
                          <p className='specieHome__main_specieContent'>{this.onItalicData(specie.species[0])}</p>
                          <p className='specieHome__main_specieContentName'>Genus : {specie.genus[0]}</p>
                        </div>
                      </div>
                    )
                  }
                  else {
                    return (
                      <div key={specie.id} className='specieHome__main_specieList'>
                        <img src={specie.thumbnail[0]} alt={specie.thumbnail[0]} className='specieHome__main_specieImg' />
                        <div className='specieHome__main_specieBox'>
                          <h3 className='specieHome__main_specieName'
                            onClick={() => this.routeToSpecie(specie)}>{this.onItalicSpeciesData(specie.species_name[0])}</h3>
                          <p className='specieHome__main_specieContent'>Genus : {specie.genus[0]}</p>
                          <p className='specieHome__main_specieContent'>Family : {specie.family[0]}</p>
                        </div>

                      </div>)
                  }
                })}
                <p className='specieHome__main_moreSpecies' onClick={() => this.props.history.push({
                  pathname: `/ladakh/biodiversity/${this.state.groupName}/all-species`,
                  groupName: this.state.groupName
                })}
                >... more species</p>

              </div>
            </> : <Loader
              type="ThreeDots"
              color="#3c6382"
              height={100}
              width={100}
            />}

        </div>

      </div >
    )
  }
}

export default SpecieHome;
