import React, { Component } from 'react';
import Sidebar from './Sidebar';
import { api } from '../api'
import BibliographyPage from './BibliographyPage';
import Pagination from './Pagination';
import { Redirect, withRouter } from 'react-router-dom';
import Breadcrumb from 'react-bootstrap/Breadcrumb';
import { Link } from 'react-router-dom';



class WildlifeDepartment extends Component {
  state = {
    wildlifeHierarchy: [],
    sidebarData: true,
    detailData: true,
    wildlifeData: [],
    currentPage: 1,
    postsPerPage: 1000,
    elementName: '',
    searchKeyword: '',
    searchKeywordGroup: '',
    heading: ''
  }



  // For componentDidMount
  componentDidMount() {
    const path = this.props.location.pathname
    let currentPath = path.substring(path.lastIndexOf('/') + 1)
    

    this.fetchwildlifeHier(currentPath)

  }

//  fetchBibliographySearchElement = (searchKeyword, searchKeywordGroup) => {
//    fetch(`${api.bibliographySearch}?type=biodiversity&group=${searchKeywordGroup}&keyword=${searchKeyword}`)
//      .then(response => {
//        if (!response || !response.ok) throw Error(response.status);
//        return response.json()
//      })
//      .then(({ data }) => {
//        console.log(data, 'bibliography search result data', searchKeyword)
//        let refineData = data.data.map((e) => {
//          let arr = e.split(' ')
//          let arr2 = arr.map((el) => {
//            // console.log(el, 'Check 1')
//            // let removeExtraChar = el.match(/p/i)
//            // console.log(removeExtraChar)
//
//            return el.replace(new RegExp(`\\b${searchKeyword}\\b`, 'gi'), `<mark class='text-capitalize'>${searchKeyword}</mark>`)
//
//
//          })
//
//          // console.log(arr2, 'CHECK 2')
//          return arr2.join(' ')
//        })
//
//        console.log(refineData, 'CHECK 3')
//
//        this.setState({ bibliographyData: refineData, searchKeyword, searchKeywordGroup },
//          () => localStorage.removeItem('bibliographySearchIteam'))
//
//
//      })
//      .catch(err => console.log('could not fetch bibliography search element data', err))
//  }


fetchwildlifeHier = (entit) => {
   
    fetch(`${api.wildlifeDepartmentHier}?type=${entit}`)
      .then(response => {
        if (!response || !response.ok) throw Error(response.status);
        return response.json()
      })
      .then((data) => {
      
        
        this.setState({
          wildlifeHierarchy: data['hier_level'],
          elementName: data.hier_level[0]['list_ele'][0].id,
        }, () => {
          const { searchKeyword, searchKeywordGroup } = { ...JSON.parse(localStorage.getItem('cultureSearchIteam')) }
         
          searchKeyword ?
            this.fetchcultureSearchElement(searchKeyword, searchKeywordGroup) :
            this.fetchwildlifeData(entit)

        })
      })
      .catch(err => console.log('could not fetch wildlifedata hierarchy', err))
  }


  fetchwildlifeData = (currentpath) => {
    //  TO DO 
     
//console.log(this.state.elementName,"abababab")
    fetch(`${api.introductionwildlifeData}?type=${currentpath}&element=${this.state.elementName}`)
      .then(response => {
        if (!response || !response.ok) throw Error(response.status);
        return response.json()
      })
      .then(({ data }) => {
       // console.log(data, 'culture data')
        var Heading = this.state.elementName
        var Heading = Heading.replace(/[#_]/g,' ');
        this.setState({ wildlifeData: data.element_data,
          heading:Heading})

      })
      .catch(err => console.log('could not fetch wildlife data data', err))
  }

  getElementData = (name, currentPath) => {
    // let name1 = name === 'political sciences' ? 'political_science' : name
    this.setState({ elementName: name, searchKeywordGroup: '', searchKeyword: '' }, () => this.fetchwildlifeData(currentPath))

  }


  render() {

    

    //uppercase of pagename
    const pageName= this.props.match.params.type
     const pagename= pageName.charAt(0).toUpperCase().concat(pageName.slice(1) )
     const pgname=pagename.replace(/_/g ," ")
    // re-route if group not exists
    const path = this.props.location.pathname
    let currentLocation = path.substring(path.lastIndexOf('/') + 1)
    //console.log(currentLocation, 'culjas;ld')
   if (currentLocation==="research_academic_institutions" || currentLocation==="prominent_non-governmental_organisations" || currentLocation==="tourism") return <Redirect to='/ladakh/not_found' />

    // get current posts
    const { wildlifeData, currentPage, postsPerPage, searchKeyword, searchKeywordGroup } = this.state;
    //console.log(this.state , "babababashshsnsns")

    const indexOfLastPost = currentPage * postsPerPage;
    const indexOfFirstPost = indexOfLastPost - postsPerPage;
    const currentPosts = wildlifeData.slice(indexOfFirstPost, indexOfLastPost);


    // change page
    const paginate = (pageNumber) => this.setState({ currentPage: pageNumber });
    return (
      
      <section style={{height:"100% "}} >
      <nav style={{marginTop:16 , paddingLeft:20}} aria-label="breadcrumb">
  <ol className="breadcrumb">
    <li className="breadcrumb-item"><Link to="/ladakh">Home</Link></li>
    <li className="breadcrumb-item"><Link to="/ladakh/introduction">Introduction</Link></li>
    <li className="breadcrumb-item active" aria-current="page">{`${pgname}`}</li>
  </ol>
</nav>

      <main className='bioliography' >
        {this.state.wildlifeHierarchy.length ? <Sidebar
          list={this.state.wildlifeHierarchy}
          hasFunction
          getElementData={this.getElementData}
          currentPath={currentLocation} /> : ''}
          {/* <div style={{ marginLeft:"auto" , marginRight:"auto",  width:"100%" , height:"550px" , overflowY:"scroll"  }}> */}
        <div className='bioliography__body'>
          {this.props.forSearchResult ? 'Searched Result' :
            <>
              {searchKeyword ?
                <>
                  <h1 className='bioliography__heading'>Search results: {searchKeyword}</h1>
                  <h3 className='bioliography__heading' style={{ marginTop: '2rem' }}>{searchKeywordGroup}</h3>


                </> :
                <h1 className='bioliography__heading'>{this.state.heading}</h1>
              }
              

              {/* <BibliographyPage data={currentPosts} /> */}
              

             {this.state.wildlifeData!=[] ? 
                <div className='bioliography__content'>
                      {this.state.wildlifeData.map((content, i) => {
                        //console.log(content.type ,"11111")
                          if (content.type === "text") {
                            return <p   key={i}>{content.content}</p>;
                          }else if (content.type === "heading")
                          {//console.log(content)
                           return  <p  key={i}><b>{content.content.replace("[" , "")}</b></p>;
                          }
                           else if (content.type === "image"){
                             //console.log(content)
                              return <img key={i} src={content.content} alt={`Image ${i}`} width="420" height="300" />;
                            
                           }

                           
                          else if (content.type === "meta_data"){
                            return <p  key={i}><i>{content.content}</i></p>;}
                          else if (content.type === "link"){
                            return <p  key={i}><b>{content.content} </b>: <a href={content.link} target="_blank">{content.link}</a></p>;
                          }
                          else if (content.type=="table"){
                            //console.log(content.content[0]['Designation'])
                            return <div >
                              <table className='table' >
                                <thead className='th'>
                                  <tr >
                                    <th className='th'  >Name</th>
                                    <th className='th' >Designation</th>
                                    <th  className='th'>Contact:</th>
                                    <th  className='th'>Email</th>
                                  </tr>
                                </thead>
                                <tbody>
          {content.content.map(row => (
            <tr key={row.id}>
              <td className='td' >{row.Name}</td>
              <td className='td'>{row.Designation}</td>
              <td className='td'>{row.Contact}</td>
              <td className='td'>{row.Email}</td>
            </tr>
          ))}
        </tbody>
                              </table>
                            </div>
                          
                            
                          }

                        })
                        
                      }
                      </div> :  <Redirect to='/ladakh/not_found' />}
                      

              
              

            </>}
            

        </div>
{/*         </div> */}
      </main>
      </section>

    )
  }
}

export default withRouter(WildlifeDepartment)